//| Ns Variation Percent Range

#include <_Custom_Generica/Datas.mqh>

#property copyright "Copyright 2020, Natã Pereira"
#property version "2.0"
//--- Config indicador
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_plots 7
//--- 1
#property indicator_label1 "Max Mensal"
#property indicator_color1 Yellow
#property indicator_type1 DRAW_LINE
//--- 2
#property indicator_label2 "Max Semanal"
#property indicator_color2 Purple
#property indicator_type2 DRAW_LINE
//--- 3
#property indicator_label3 "Max Diaria"
#property indicator_color3 DodgerBlue
#property indicator_type3 DRAW_LINE
//--- 4
#property indicator_label4 "Meio"
#property indicator_color4 AliceBlue
#property indicator_type4 DRAW_LINE
//--- 5
#property indicator_label5 "Min Diaria"
#property indicator_color5 DodgerBlue
#property indicator_type5 DRAW_LINE
//--- 6
#property indicator_label6 "Min Semanal"
#property indicator_color6 Purple
#property indicator_type6 DRAW_LINE
//--- 7
#property indicator_label7 "Min Mensal"
#property indicator_color7 Yellow
#property indicator_type7 DRAW_LINE
//---- buffers
double MaxMes[];
double MaxSem[];
double MaxDia[];
double Meio[];
double MinDia[];
double MinSem[];
double MinMes[];
//-- Maximas
double ultimaMaxM = 0;
double ultimaMaxS = 0;
double ultimaMaxD = 0;
//--- Meio
double ultimoMeio = 0;
//--- Minimas
double ultimaMinM = 0;
double ultimaMinS = 0;
double ultimaMinD = 0;
//--- Controle de datas
MqlDateTime dataMes,dataSem,dataDia;
DataT datas;
//--- Inputs
input double variacaoPercentilIn = 0; //Variação percentil
input int atrasoVelas = 0; //Atraso de velas
//--- Variaveis de controle de input
double variacaoPercentil;
int acessoAtrasado;
//---
int OnInit(){
  //--- Mapeamento dos buffers
  SetIndexBuffer(0, MaxMes, INDICATOR_DATA);
  SetIndexBuffer(1, MaxSem, INDICATOR_DATA);
  SetIndexBuffer(2, MaxDia, INDICATOR_DATA);
  SetIndexBuffer(3, Meio, INDICATOR_DATA);
  SetIndexBuffer(4, MinDia, INDICATOR_DATA);
  SetIndexBuffer(5, MinSem, INDICATOR_DATA);
  SetIndexBuffer(6, MinMes, INDICATOR_DATA);
  //--- Configura como series = Inverte o acesso do array
  ArraySetAsSeries(MaxMes, true);
  ArraySetAsSeries(MaxSem, true);
  ArraySetAsSeries(MaxDia, true);
  ArraySetAsSeries(Meio, true);
  ArraySetAsSeries(MinDia, true);
  ArraySetAsSeries(MinSem, true);
  ArraySetAsSeries(MinMes, true);
  //--- Inicia as datas com valor negativo
  dataMes.day = -1;
  dataSem.day = -1;
  dataDia.day = -1;
  //--- Atribuição em percentual para calculo a partir do input
  variacaoPercentil = 1 + (variacaoPercentilIn / 100);
  return(INIT_SUCCEEDED);
}
//---
int OnCalculate(const int rates_total, const int prev_calculated, const datetime &time[], const double &open[], const double &high[], const double &low[], const double &close[], const long &tick_volume[], const long &volume[], const int &spread[]){
  //--- Configura como series = Inverte o acesso do array
  ArraySetAsSeries(close, true);
  ArraySetAsSeries(open, true);
  ArraySetAsSeries(high, true);
  ArraySetAsSeries(low, true);
  ArraySetAsSeries(time, true);
  //--- Valida se as datas estão corretas
  if(dataMes.day == -1){
    datetime ultimaData = time[ArraySize(time)-1];
    TimeToStruct(ultimaData, dataMes);
    TimeToStruct(ultimaData, dataSem);
    TimeToStruct(ultimaData, dataDia);
  }
  //--- Itera sobre os candles passados até o atual
  for(int i = rates_total - prev_calculated + atrasoVelas; i >= atrasoVelas; i--){
    acessoAtrasado = i - atrasoVelas;
    if(i >= rates_total)
      continue;

    MqlDateTime dataAtual;
    TimeToStruct(time[i], dataAtual);
    //--- Dia diferente
    if(datas.dataMenor(dataDia, dataAtual)){
      dataDia = dataAtual;
      ultimaMaxD = 0;
      ultimaMinD = 0;
    }
    //--- Semana diferente
    if(datas.semanaAnterior(dataSem, dataAtual)){
      dataSem = dataAtual;
      ultimaMaxS = 0;
      ultimaMinS = 0;
    }
    //--- Mes diferente
    if(datas.mesAnterior(dataMes, dataAtual)){
      dataMes = dataAtual;
      ultimaMaxM = 0;
      ultimaMinM = 0;
    }
    //--- Atualizar Máximas e Minimas validando para executar o calculo de meios novamente
    bool nmx = novaMax(ultimaMaxD, ultimaMaxS, ultimaMaxM, high[i]);
    bool nmi = novaMin(ultimaMinD, ultimaMinS, ultimaMinM, low[i]);
    if(nmx || nmi)
      ultimoMeio = meioMaxMin(ultimaMaxD, ultimaMaxS, ultimaMaxM, ultimaMinD, ultimaMinS, ultimaMinM);

    //--- Atribui os valores nos buffers
    MaxMes[acessoAtrasado] = calcVPRMx(ultimaMaxM);
    MaxSem[acessoAtrasado] = calcVPRMx(ultimaMaxS);
    MaxDia[acessoAtrasado] = calcVPRMx(ultimaMaxD);
    Meio[acessoAtrasado] = ultimoMeio;
    MinDia[acessoAtrasado] = calcVPRMin(ultimaMinD);
    MinSem[acessoAtrasado] = calcVPRMin(ultimaMinS);
    MinMes[acessoAtrasado] = calcVPRMin(ultimaMinM);
  }
  return (rates_total);
}

bool novaMax(double& n1, double& n2, double& n3, double maxComp){
  bool nova = false;
  if(maxComp > n1){
    n1 = maxComp;
    nova = true;
  }
  if(maxComp > n2){
    n2 = maxComp;
    nova = true;
  }
  if(maxComp > n3){
    n3 = maxComp;
    nova = true;
  }
  return nova;
}

bool novaMin(double& n1, double& n2, double& n3, double minComp){
  bool nova = false;
  if(minComp < n1 || n1 <= 0){
    n1 = minComp;
    nova = true;
  }
  if(minComp < n2 || n2 <= 0){
    n2 = minComp;
    nova = true;
  }
  if(minComp < n3 || n3 <= 0){
    n3 = minComp;
    nova = true;
  }
  return nova;
}

double meioMaxMin(double mx1, double mx2, double mx3, double mi1, double mi2, double mi3){
  return (mx1 + mx2 + mx3 + mi1 + mi2 + mi3) / 6;
}

double calcVPRMx(double num){
  if(variacaoPercentil == 0)
    return num;

  return num * variacaoPercentil;
}

double calcVPRMin(double num){
  if(variacaoPercentil == 0)
    return num;
  //--- Para minima retorna a subtração do percentual inserido
  return num - ((num * variacaoPercentil) - num);
}